#debuginfo not supported with Go
%global debug_package %{nil}
# modifying the Go binaries breaks the DWARF debugging
%global __os_install_post %{_rpmconfigdir}/brp-compress

%global commit 94d0af58c1d2afaa5541fe48729002888f370456
%global shortcommit %(c=%{commit}; echo ${c:0:7})

%global import_path github.com/jessfraz/

Name:       reg
Version:    0.2.0
Release:    2.git.0.%{shortcommit}%{?dist}
Summary:    Docker registry v2 command line client


License:    MIT
URL:        https://%{import_path}/%{name}

# Upstream doesn't have any official releases or any git tags to reference,
# however in the source code it claims to be version "0.2.0" as is found by
# executing the `reg` command and getting usage output.
#
Source0:    https://%{import_path}/%{name}/archive/%{commit}/%{name}-%{version}.tar.gz

# Upstream advertises this as something that's meant to be run in a container
# and doesn't provide a systemd unit or sysV init script or sysconfig files
# so I'm providing them here.
Source1:    reg-server.service
Source2:    sysconfig.reg-server

# Fixes the reg-server command to handle copying the tmpfile across filesystems
#
# Issue: https://github.com/jessfraz/reg/issues/8
#
# Pull Request: https://github.com/jessfraz/reg/pull/9
Patch0: reg-server-0.2.0-fix-move-file.patch

BuildRequires: golang
BuildRequires: systemd

# The following section is automatically populated by running the below python
# one-liner at the base dir of a git checkout of the source code.
#
#   $ git clone https://github.com/jessfraz/reg.git
#   $ cd reg
#   $ python -c 'import json; print "\n".join(["Provides: bundled(golang({})) = {}".format(dep[u"importpath"], dep[u"revision"]) for dep in json.load(open("vendor/manifest", "r"))[u"dependencies"]])'
#
# Bundled Provides are defined as per Fedora Guidelines:
#   https://fedoraproject.org/wiki/Packaging:Guidelines#Bundling_and_Duplication_of_system_libraries
#
Provides: bundled(golang(github.com/BurntSushi/toml)) = 99064174e013895bbd9b025c31100bd1d9b590ca
Provides: bundled(golang(github.com/Sirupsen/logrus)) = 0208149b40d863d2c1a2f8fe5753096a9cf2cc8b
Provides: bundled(golang(github.com/docker/distribution)) = 08b06dc023674763e7b36d404cf0c7664cee1f5e
Provides: bundled(golang(github.com/docker/docker/api/types)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/cli/config)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/opts)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/homedir)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/httputils)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/idtools)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/ioutils)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/jsonlog)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/jsonmessage)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/longpath)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/progress)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/random)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/streamformatter)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/stringid)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/system)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/tarsum)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/pkg/term)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/registry)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/Azure/go-ansiterm)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/Microsoft/go-winio)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/Nvveen/Gotty)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/Sirupsen/logrus)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/distribution)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/docker-credential-helpers/client)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/docker-credential-helpers/credentials)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/go-connections/nat)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/go-connections/sockets)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/go-connections/tlsconfig)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/go-units)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/docker/libtrust)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/gorilla/context)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/gorilla/mux)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/opencontainers/go-digest)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/opencontainers/runc/libcontainer/user)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/pkg/errors)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/github.com/spf13/pflag)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/golang.org/x/net/context)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/golang.org/x/net/proxy)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/golang.org/x/sys/unix)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/golang.org/x/sys/windows)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/docker/vendor/golang.org/x/time/rate)) = 338565805c31783c63f9bb35d5b24f4c0c5656d3
Provides: bundled(golang(github.com/docker/go-connections/nat)) = a2afab9802043837035592f1c24827fb70766de9
Provides: bundled(golang(github.com/docker/go-units)) = 0dadbb0345b35ec7ef35e228dabb8de89a65bf52
Provides: bundled(golang(github.com/docker/libtrust)) = aabc10ec26b754e797f9028f4589c5b7bd90dc20
Provides: bundled(golang(github.com/dustin/go-humanize)) = 259d2a102b871d17f30e3cd9881a642961a1e486
Provides: bundled(golang(github.com/gorilla/context)) = 08b5f424b9271eedf6f9f0ce86cb9396ed337a42
Provides: bundled(golang(github.com/gorilla/mux)) = 599cba5e7b6137d46ddf58fb1765f5d928e69604
Provides: bundled(golang(github.com/opencontainers/go-digest)) = aa2ec055abd10d26d539eb630a92241b781ce4bc
Provides: bundled(golang(github.com/opencontainers/runc/libcontainer/user)) = 291bf601105c97dc1aa631fdfb7fca63c947319b
Provides: bundled(golang(github.com/peterhellberg/link)) = 3eea38ca14b7b3252feea5daf92be3864209eb1d
Provides: bundled(golang(github.com/urfave/cli)) = 9e5b04886c4bfee2ceba1465b8121057355c4e53
Provides: bundled(golang(golang.org/x/net/context)) = d379faa25cbdc04d653984913a2ceb43b0bc46d7
Provides: bundled(golang(golang.org/x/sys/unix)) = e48874b42435b4347fc52bdee0424a52abc974d7
Provides: bundled(golang(gopkg.in/airbrake/gobrake.v2)) = 668876711219e8b0206e2994bf0a59d889c775aa
Provides: bundled(golang(gopkg.in/gemnasium/logrus-airbrake-hook.v2)) = bfee1239d796830ca346767650cce5ba90d58c57
Provides: bundled(golang(gopkg.in/urfave/cli.v1)) = 0bdeddeeb0f650497d603c4ad7b20cfe685682f6
Provides: bundled(golang(gopkg.in/yaml.v2)) = a3f3340b5840cee44f372bddb5880fcbc419b46a

%description
Docker registry v2 client.

%package server
Summary: A static UI for a docker registry
Requires: systemd
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd

%description server
A static UI for a docker registry. Comes with vulnerability scanning if you
have a CoreOS Clair server set up.


%prep
%setup -q

%patch0 -p1

# Have to move things around because of how golang likes to search $GOPATH
cd ../
mv $OLDPWD hack
mkdir $OLDPWD
cd $OLDPWD
mkdir -p $(pwd)/go/src/%{import_path}
mv ../hack $(pwd)/go/src/%{import_path}/%{name}


%build
export GOPATH="$(pwd)/go:%{buildroot}%{gopath}:%{gopath}"

cd $(pwd)/go/src/%{import_path}/%{name}

go build -o reg .

go build -o reg-server ./server


%install

# Install the binaries
cd ./go/src/%{import_path}/%{name}/
mkdir -p %{buildroot}%{_bindir}
install -p -m 0755 %{name} %{buildroot}%{_bindir}/%{name}
install -p -m 0755 %{name}-server %{buildroot}%{_bindir}/%{name}-server

# Install templates and static content
mkdir -p %{buildroot}%{_sharedstatedir}/%{name}-server
install -d server/templates/ %{buildroot}/%{_sharedstatedir}/%{name}-server/templates/
install -d server/static/ %{buildroot}%{_sharedstatedir}/%{name}-server/static/
cp -p -r server/templates/* %{buildroot}%{_sharedstatedir}/%{name}-server/templates/
cp -p -r server/static/* %{buildroot}%{_sharedstatedir}/%{name}-server/static/

# Install the systemd unit
mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}-server.service

# Install the sysconfig file
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -p -m 0640 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}-server

# Setup doc files for doc macro
for i in README.md Dockerfile Makefile
do
    cp -p ${i} %{_builddir}/%{name}-%{version}/
done

# Setup doc files for reg-server doc macro
mv server/README.md server/README-server.md
for i in README-server.md home.png vuln.png
do
    cp -p server/${i} %{_builddir}/%{name}-%{version}/
done

# Setup license file for license macro
cp -p LICENSE %{_builddir}/%{name}-%{version}/


%post server
%systemd_post %{name}-server.service

%preun server
%systemd_preun %{name}-server.service

%postun server
%systemd_postun


%files
%doc README.md Dockerfile Makefile
%license LICENSE
%{_bindir}/%{name}

%files server
%doc README.md home.png vuln.png
%license LICENSE
%{_bindir}/%{name}-server
%{_unitdir}/%{name}-server.service
%dir %{_sharedstatedir}/%{name}-server/
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}-server
%config(noreplace) %{_sharedstatedir}/%{name}-server/static/
%config(noreplace) %{_sharedstatedir}/%{name}-server/templates/

%changelog
* Tue Mar 21 2017 Adam Miller <maxamillion@fedoraproject.org> - 0.2.0-2.git.0.94d0af5
- Move static/templates and systemd workingdir to /var/lib/reg-server
- Change Source0 to point to github archive url instead of local git-archive
- Fix tabs vs spaces in the spec file

* Tue Mar 14 2017 Adam Miller <maxamillion@fedoraproject.org> - 0.2.0-1.git.0.94d0af5
- First package for Fedora
